'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _icons = require('../../../utils/icons');

var _SidebarContext = require('../SidebarContext');

var _SidebarContext2 = _interopRequireDefault(_SidebarContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SidebarSubmenuAccordion = function (_Component) {
  _inherits(SidebarSubmenuAccordion, _Component);

  function SidebarSubmenuAccordion() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SidebarSubmenuAccordion);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SidebarSubmenuAccordion.__proto__ || Object.getPrototypeOf(SidebarSubmenuAccordion)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false
    }, _this.handleTitleClick = function () {
      _this.setState(function (_ref2) {
        var open = _ref2.open;
        return { open: !open };
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SidebarSubmenuAccordion, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          className = _props.className,
          children = _props.children,
          icon = _props.icon,
          content = _props.content,
          otherProps = _objectWithoutProperties(_props, ['active', 'className', 'children', 'icon', 'content']);

      var open = this.state.open;

      var classes = (0, _classnames2.default)('inloco-layout__sidebar-submenu-accordion', 'submenu-accordion', className);
      return _react2.default.createElement(
        _semanticUiReact.Menu.Item,
        _extends({ className: classes, link: true, active: active }, otherProps),
        _react2.default.createElement(
          _semanticUiReact.Accordion.Title,
          { active: open, onClick: this.handleTitleClick },
          _semanticUiReact.Icon.create((0, _icons.normalizeIconProp)(icon), { autoGenerateKey: false }),
          _react2.default.createElement(
            'span',
            { className: 'inloco-layout__sidebar-submenu-accordion-content' },
            content
          ),
          _react2.default.createElement(_semanticUiReact.Icon, { className: 'keyboard arrow down dropdown' })
        ),
        _react2.default.createElement(
          _semanticUiReact.Transition,
          { visible: open, animation: 'slide down', duration: 250 },
          _react2.default.createElement(
            _semanticUiReact.Accordion.Content,
            { as: _semanticUiReact.Menu.Menu, active: open },
            children
          )
        )
      );
    }

    /**
     * Scroll the sidebar down when the footer accordion opens, as its content
     * may cause the scrollbar to appear for the first time.
     */

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(props, _ref3) {
      var prevOpen = _ref3.open;
      var open = this.state.open;
      var _context = this.context,
          isFooter = _context.isFooter,
          scrollElement = _context.scrollRef.current;

      if (isFooter && open && !prevOpen) {
        scrollElement.scrollTo(0, scrollElement.scrollHeight);
      }
    }
  }]);

  return SidebarSubmenuAccordion;
}(_react.Component);

SidebarSubmenuAccordion.propTypes = {
  active: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  content: _propTypes2.default.node.isRequired
};
SidebarSubmenuAccordion.contextType = _SidebarContext2.default;
exports.default = SidebarSubmenuAccordion;