'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _PropTypes$shape, _buttons;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Buttons = {
  CANCEL: 'cancel',
  PREVIOUS: 'previous',
  SAVE: 'save',
  NEXT: 'next',
  FINISH: 'finish'
};

var WizardFooterBasicControls = function (_Component) {
  _inherits(WizardFooterBasicControls, _Component);

  function WizardFooterBasicControls() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, WizardFooterBasicControls);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardFooterBasicControls.__proto__ || Object.getPrototypeOf(WizardFooterBasicControls)).call.apply(_ref, [this].concat(args))), _this), _this.handleNext = function () {
      var _this$props = _this.props,
          currentStep = _this$props.currentStep,
          onChangeStep = _this$props.onChangeStep;

      onChangeStep(currentStep + 1);
    }, _this.handlePrevious = function () {
      var _this$props2 = _this.props,
          currentStep = _this$props2.currentStep,
          onChangeStep = _this$props2.onChangeStep;

      onChangeStep(currentStep - 1);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(WizardFooterBasicControls, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          currentStep = _props.currentStep,
          buttons = _props.buttons,
          onCancel = _props.onCancel,
          onFinish = _props.onFinish,
          onSave = _props.onSave,
          showBackOnFirstStep = _props.showBackOnFirstStep,
          showSaveButton = _props.showSaveButton,
          totalSteps = _props.totalSteps;

      var isLastStep = currentStep === totalSteps - 1;
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _semanticUiReact.Button.create(buttons[Buttons.CANCEL], {
          autoGenerateKey: false,
          defaultProps: {
            onClick: onCancel,
            type: 'button'
          }
        }),
        showSaveButton && !isLastStep && _semanticUiReact.Button.create(buttons[Buttons.SAVE], {
          autoGenerateKey: false,
          defaultProps: {
            onClick: onSave,
            type: 'submit'
          }
        }),
        (currentStep > 0 || showBackOnFirstStep) && _semanticUiReact.Button.create(buttons[Buttons.PREVIOUS], {
          autoGenerateKey: false,
          defaultProps: {
            onClick: this.handlePrevious,
            type: 'button'
          }
        }),
        !isLastStep && _semanticUiReact.Button.create(buttons[Buttons.NEXT], {
          autoGenerateKey: false,
          defaultProps: {
            className: 'blue',
            onClick: this.handleNext,
            type: 'submit'
          }
        }),
        isLastStep && _semanticUiReact.Button.create(buttons[Buttons.FINISH], {
          autoGenerateKey: false,
          defaultProps: {
            className: 'blue',
            onClick: onFinish,
            type: 'submit'
          }
        })
      );
    }
  }]);

  return WizardFooterBasicControls;
}(_react.Component);

WizardFooterBasicControls.propTypes = {
  currentStep: _propTypes2.default.number.isRequired,
  buttons: _propTypes2.default.shape((_PropTypes$shape = {}, _defineProperty(_PropTypes$shape, Buttons.CANCEL, _propTypes2.default.any), _defineProperty(_PropTypes$shape, Buttons.PREVIOUS, _propTypes2.default.any), _defineProperty(_PropTypes$shape, Buttons.SAVE, _propTypes2.default.any), _defineProperty(_PropTypes$shape, Buttons.NEXT, _propTypes2.default.any), _defineProperty(_PropTypes$shape, Buttons.FINISH, _propTypes2.default.any), _PropTypes$shape)),
  onCancel: _propTypes2.default.func,
  onChangeStep: _propTypes2.default.func.isRequired,
  onFinish: _propTypes2.default.func,
  onSave: _propTypes2.default.func,
  showBackOnFirstStep: _propTypes2.default.bool,
  showSaveButton: _propTypes2.default.bool,
  totalSteps: _propTypes2.default.number.isRequired
};
WizardFooterBasicControls.defaultProps = {
  buttons: (_buttons = {}, _defineProperty(_buttons, Buttons.CANCEL, 'Cancel'), _defineProperty(_buttons, Buttons.PREVIOUS, 'Previous'), _defineProperty(_buttons, Buttons.SAVE, 'Save'), _defineProperty(_buttons, Buttons.NEXT, 'Next'), _defineProperty(_buttons, Buttons.FINISH, 'Finish'), _buttons)
};
WizardFooterBasicControls.Buttons = Buttons;
exports.default = WizardFooterBasicControls;