'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Wizard = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _Layout = require('../Layout');

var _Footer = require('./Footer');

var _Footer2 = _interopRequireDefault(_Footer);

var _BasicControls = require('./Footer/BasicControls');

var _BasicControls2 = _interopRequireDefault(_BasicControls);

var _Step = require('./Step');

var _Step2 = _interopRequireDefault(_Step);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wizard = exports.Wizard = function (_Component) {
  _inherits(Wizard, _Component);

  function Wizard() {
    _classCallCheck(this, Wizard);

    return _possibleConstructorReturn(this, (Wizard.__proto__ || Object.getPrototypeOf(Wizard)).apply(this, arguments));
  }

  _createClass(Wizard, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          currentStep = _props.currentStep,
          footerProps = _props.footerProps,
          onChangeStep = _props.onChangeStep,
          steps = _props.steps,
          otherProps = _objectWithoutProperties(_props, ['children', 'className', 'currentStep', 'footerProps', 'onChangeStep', 'steps']);

      var classes = (0, _classnames2.default)('inloco-wizard', className);
      return _react2.default.createElement(
        'div',
        _extends({ className: classes }, otherProps),
        _react2.default.createElement(
          'div',
          { className: 'inloco-wizard__content' },
          _react2.default.createElement(
            _semanticUiReact.Transition.Group,
            { animation: 'fly up', duration: 500 },
            _react2.default.Children.toArray(children)[currentStep]
          )
        ),
        _react2.default.createElement(_Footer2.default, _extends({
          currentStep: currentStep,
          onChangeStep: onChangeStep,
          steps: steps
        }, footerProps))
      );
    }
  }]);

  return Wizard;
}(_react.Component);

Wizard.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node.isRequired,
  currentStep: _propTypes2.default.number,
  footerProps: _propTypes2.default.object,
  onChangeStep: _propTypes2.default.func,
  steps: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired
};
Wizard.defaultProps = {
  currentStep: 0,
  footerProps: {}
};
Wizard.Footer = _Footer2.default;
Wizard.FooterBasicControls = _BasicControls2.default;
Wizard.Step = _Step2.default;
exports.default = Wizard;